Let RPC mechanism use cause vector
09/09/2011 12:47 PM - J. Wienke

Status: Resolved Start date: 09/09/2011
Priority: Normal Due date:
Assignee: J. Moringen % Done: 100%
Category: Protocol Estimated time: 0.00 hour
Target version: 0.5
Description

Now that there is a formal way to reference what caused on event, let the RPC reply event reference their request events.
Has to be implemented in
    -  C++ ✓
    -  Java ✓
    -  Python ✓
    -  Common Lisp ✓
    -  Logger ✓

Related issues:
Blocked by Robotics Service Bus - Enhancement # 498: Integrate causal vector ... Closed 09/08/2011

Associated revisions
Revision 2c220b22 - 10/20/2011 09:23 PM - J. Moringen
Use cause vectors in src/patterns/{local,remote}-server.lisp
refs #565
    -  src/patterns/local-server.lisp (call t local-method event): use

  `event-id/opaque' to obtain a cause event id; add it to the reply
  event

    -  src/patterns/remote-server.lisp
  (setf %method-listener :after t remote-method): use
  `event-id/opaque' and cause mechanism instead of `event-id' and
  meta-data mechanism to indicate associated request
  (call t remote-method event): extract the first cause instead of a
  meta-data item from the reply event; use `%event-id->key' to convert
  event id to suitable keys
  (%event-id->key): new function; helper function for converting event
  ids to keys suitable for hash-table lookup

Revision 01539c5e - 10/20/2011 10:30 PM - J. Moringen
Use cause vectors in src/rsb/patterns/{AbstractRemote,Local}Method.java
refs #565
    -  src/rsb/patterns/AbstractRemoteMethod.java: manage in-progress call

  using the event ids of the request events and the causes of the
  reply events

    -  src/rsb/patterns/LocalMethod.java: when creating replies, use the id
  of the request event as cause

Revision 90998250 - 10/20/2011 10:38 PM - J. Moringen
Use cause vectors in src/rsb/patterns/[Remote]Server.cpp
refs #565
    -  src/rsb/patterns/RemoteServer.cpp: manage in-progress calls using
  event ids of request events and cause event ids of reply events

    -  src/rsb/patterns/Server.cpp: use event ids of request events as
  cause in reply events

Revision 5eab59af - 10/20/2011 11:47 PM - J. Moringen
Use cause vectors for RPC communication in rsb/patterns/__init__.py
refs #565
    -  rsb/patterns/__init__.py: in RemoteMethod, use event ids of request

  events and cause event ids of reply events to track in-progress
  method calls; in LocalMethod, add event ids of request events as
  causes of reply events

Revision b22adbcb - 10/21/2011 12:14 AM - J. Moringen
Adapted call-id column in formatting/columns.lisp
fixes #565
    -  formatting/columns.lisp (define-simple-column :call-id): print uuid

  derived from first cause event id

History
#1 - 09/15/2011 09:52 AM - J. Wienke
- Subject changed from Let RPC mechanism use caus vector to Let RPC mechanism use cause vector

#2 - 09/23/2011 02:55 PM - J. Wienke
- Target version changed from rsb-0.10 to 0.5

#3 - 10/20/2011 08:54 AM - J. Wienke

Jan, for this to work we should think of a CauseFilter?

#4 - 10/20/2011 03:49 PM - J. Wienke

CauseFilter is not useful here, because the filter criterion changes over time.

#5 - 10/20/2011 04:59 PM - J. Moringen
- Category set to Protocol
- Status changed from New to In Progress

#6 - 10/20/2011 05:00 PM - J. Moringen
- Description updated

#7 - 10/21/2011 12:19 AM - J. Moringen
- Status changed from In Progress to Resolved
- % Done changed from 0 to 100

Applied in changeset r2929.
#8 - 10/21/2011 12:20 AM - J. Moringen
- Description updated
